const REGEXP = /<(svg|img|math)\s+(.*?)src="(.*?)"(.*?)\/?>/gi

const fs = require('fs')
const path = require('path')
const loaderUtils = require('loader-utils')

module.exports = function (content) {
  this.cacheable && this.cacheable()
  return content.replace(REGEXP, (match, element, preAttributes, fileName, postAttributes) => {
    const isSvgFile = path.extname(fileName).toLowerCase() === '.svg'
    const isImg = element.toLowerCase() === 'img'

    if (!isSvgFile && isImg) {
      return match
    }
    let filePath
    if (fileName.indexOf('~') >= 0) {
      let modules = this._compiler.options.resolve.modules
      modules = [
        path.join(this.context, 'node_modules'),
        path.join(this.context, '../node_modules'),
        path.join(this.context, '../../node_modules')
      ].concat(modules)
      modules.find(module => {
        const file = path.join(module, loaderUtils.urlToRequest(fileName))
        if (fs.existsSync(file)) {
          filePath = file
          return true
        }
      })
    } else {
      filePath = path.join(this.context, fileName)
    }

    if (!filePath) {
      throw new Error(`Can not resolve file ${resourcePath} in ${this.resourcePath}`)
    }
    this.addDependency(filePath)
    const fileContent = fs.readFileSync(filePath, { encoding: 'utf-8' })
    return fileContent.replace(/^<svg/, '<svg ' + preAttributes + postAttributes + ' ')
  })
}
